package saaj_klient.countries;

import jakarta.xml.soap.*;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import javax.xml.namespace.QName;
import java.io.IOException;

public class GetCountryInfo {

    public static void main(String[] args) {
        String szukanyKraj = "PL";
        final String NS = "http://www.oorsprong.org/websamples.countryinfo";

        try {
            MessageFactory mf = MessageFactory.newInstance();
            SOAPMessage request = mf.createMessage();
            SOAPBody requestBody = request.getSOAPBody();
            SOAPBodyElement fullCountryInfo = requestBody.addBodyElement(new QName(NS, "FullCountryInfo"));
            SOAPElement parametr = fullCountryInfo.addChildElement(new QName(NS, "sCountryISOCode"));
            parametr.setTextContent(szukanyKraj);

            System.out.println("Zapytanie:");
            request.writeTo(System.out);

            System.out.println("\n\nWysyłam...");
            SOAPConnectionFactory scf = SOAPConnectionFactory.newInstance();
            SOAPConnection connection = scf.createConnection();
            SOAPMessage response = connection.call(request, "http://webservices.oorsprong.org/websamples.countryinfo/CountryInfoService.wso");

            System.out.println("Mam odpowiedź:");
            response.writeTo(System.out);
            System.out.println();

            NodeList znalezione = response.getSOAPBody().getElementsByTagNameNS(NS, "sCapitalCity");
            if(znalezione.getLength() > 0) {
                String stolica = znalezione.item(0).getTextContent();
                System.out.println("Stolica: " + stolica);
            }
        } catch (SOAPException | IOException e) {
            e.printStackTrace();
        }
    }
}
